#include <stdio.h>
#include <stdlib.h>

static int show(char *s)
{
    return printf("%s", s);
}

static int guarded_show(char *(fp)(int n), int n)
{
    char *s = fp ? fp(n) : NULL;
    if (s) {
        return show(s);
    }
    return 0;
}

static char* fizz(int n)
{
    return (n % 3 == 0) ? "Fizz" : NULL;
}

static char* buzz(int n)
{
    return (n % 5 == 0) ? "Buzz" : NULL;
}

static void handle(char *s)
{
    char* (*fp[])(int) = { fizz, buzz, NULL };
    int n = atoi(s);
    if (n > 0) {
        int cnt = 0;
        for (int i = 0; fp[i] != NULL; i++) {
            cnt += guarded_show(fp[i], n);
        }
        if (cnt) {
            return;
        }
    }
    show(s);
}

int main(int argc, char *argv[])
{
    for (int i = 1; i < argc; i++) {
        char *separator = (i < argc-1) ? " " : "\n";
        handle(argv[i]);
        show(separator);
    }
    return EXIT_SUCCESS;
}
